//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <libuncia/error_handler.h>
#include <libuncia/quit/stderr_and_exit.h>


static libuncia::quit_stderr_and_exit default_error_handler;
static libuncia::quit *error_handler = &default_error_handler;


void
libuncia::error_handler_set(quit *newhndlr)
{
    error_handler = (newhndlr ? newhndlr : &default_error_handler);
}


libuncia::quit *
libuncia::error_handler_get()
{
    return error_handler;
}
