//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <libuncia/input/echo.h>
#include <libuncia/input/null.h>


libuncia::input_echo::~input_echo()
{
}


libuncia::input_echo::input_echo(const std::string &a_text) :
    text(a_text),
    position(0)
{
    if (!text.empty() && text[text.size() - 1] != '\n')
        text += '\n';
}


libuncia::input::pointer
libuncia::input_echo::create(const std::string &a_text)
{
    if (a_text.empty())
        return libuncia::input_null::create();
    return pointer(new input_echo(a_text));
}


ssize_t
libuncia::input_echo::read(void *data, size_t size)
{
    if (position >= text.size())
        return 0;
    if (position + size > text.size())
        size = text.size() - position;
    memcpy(data, text.c_str() + position, size);
    position += size;
    return size;
}


std::string
libuncia::input_echo::filename_get()
    const
{
    return "echo";
}
