//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/input/filter/head.h>
#include <libuncia/input/null.h>


libuncia::input_filter_head::~input_filter_head()
{
}


libuncia::input_filter_head::input_filter_head(const pointer &a_deeper,
        long a_limit) :
    input_filter(a_deeper),
    limit(a_limit)
{
}


libuncia::input_filter_head::pointer
libuncia::input_filter_head::create(const pointer &a_deeper, long a_limit)
{
    if (a_limit <= 0)
        return libuncia::input_null::create();
    return pointer(new input_filter_head(a_deeper, a_limit));
}


ssize_t
libuncia::input_filter_head::read(void *data, size_t size)
{
    char *start = (char *)data;
    char *end = start + size;
    char *cp = start;
    while (cp < end)
    {
        if (limit <= 0)
            break;
        char c = 0;
        if (!deeper_get(c))
        {
            limit = 0;
            break;
        }
        *cp++ = c;
        if (c == '\n')
            --limit;
    }
    return (cp - start);
}
