//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/input/filter/reverse.h>


libuncia::input_filter_reverse::~input_filter_reverse()
{
}


libuncia::input_filter_reverse::input_filter_reverse(const pointer &a_deeper) :
    input_filter(a_deeper)
{
}


libuncia::input_filter_reverse::pointer
libuncia::input_filter_reverse::create(const pointer &a_deeper)
{
    return pointer(new input_filter_reverse(a_deeper));
}


ssize_t
libuncia::input_filter_reverse::read(void *data, size_t size)
{
    char *start = (char *)data;
    char *end = start + size;
    char *cp = start;
    while (cp < end)
    {
        if (buffer.empty())
        {
            char c = 0;
            if (!deeper_get(c))
                break;
            buffer.push_back('\n');
            while (c != '\n')
            {
                buffer.push_back(c);
                if (!deeper_get(c))
                    break;
            }
        }

        *cp++ = buffer.back();
        buffer.pop_back();
    }
    return (cp - start);
}
