//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <libuncia/input/istream.h>


libuncia::input_istream::~input_istream()
{
}


libuncia::input_istream::input_istream(std::istream &a_deeper) :
    deeper(a_deeper)
{
}


libuncia::input::pointer
libuncia::input_istream::create(std::istream &a_deeper)
{
    return pointer(new input_istream(a_deeper));
}


ssize_t
libuncia::input_istream::read(void *data, size_t size)
{
    char *start = (char *)data;
    char *end = start + size;
    char *cp = start;
    while (cp < end)
    {
        char c = 0;
        if (!deeper.get(c))
            break;
        *cp++ = c;
    }
    return (cp - start);
}


std::string
libuncia::input_istream::filename_get()
    const
{
    return "anonymous istream";
}
