//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/ostream.h>
#include <libuncia/ostreambuf.h>


libuncia::ostream::~ostream()
{
    sync();
    delete rdbuf();
}


libuncia::ostream::ostream(const output::pointer &rhs) :
    std::ostream(libuncia::ostreambuf::create(rhs)),
    raw(rhs)
{
}


void
libuncia::ostream::fatal_error(const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    fatal_error_v(fmt, ap);
    va_end(ap);
}


void
libuncia::ostream::fatal_error_v(const char *fmt, va_list ap)
{
    raw->fatal_error_v(fmt, ap);
}


std::string
libuncia::ostream::filename_get()
    const
{
    return raw->filename_get();
}
