//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <string>

#include <libuncia/error_handler.h>
#include <libuncia/output.h>


void
libuncia::output::fatal_error(const char *fmt, ...)
    const
{
    va_list ap;
    va_start(ap, fmt);
    fatal_error_v(fmt, ap);
    va_end(ap);
}


void
libuncia::output::fatal_error_v(const char *fmt, va_list ap)
    const
{
    char buf[2000];
    vsnprintf(buf, sizeof(buf), fmt, ap);
    error_handler_get()->fatal_error("%s: %s", filename_get().c_str(), buf);
}
