//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/output/filter/crlf.h>


libuncia::output_filter_crlf::~output_filter_crlf()
{
}


libuncia::output_filter_crlf::output_filter_crlf(const pointer &a_deeper) :
    output_filter(a_deeper),
    prev_was_cr(false)
{
}


libuncia::output::pointer
libuncia::output_filter_crlf::create(const pointer &a_deeper)
{
    return pointer(new output_filter_crlf(a_deeper));
}


ssize_t
libuncia::output_filter_crlf::write(const void *data, size_t size)
{
    const char *cp = (const char *)data;
    const char *end = cp + size;
    while (cp < end)
    {
        char c = *cp++;
        if (c == '\n' && !prev_was_cr)
            deeper_putc('\r');
        deeper_putc(c);
        prev_was_cr = (c == '\r');
    }
    return size;
}
