//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/output/filter/prefix.h>


libuncia::output_filter_prefix::~output_filter_prefix()
{
}


libuncia::output_filter_prefix::output_filter_prefix(const pointer &a_deeper,
        const std::string &a_text) :
    output_filter(a_deeper),
    text(a_text),
    start_of_line(true)
{
}


libuncia::output_filter_prefix::pointer
libuncia::output_filter_prefix::create(const pointer &a_deeper,
    const std::string &a_text)
{
    if (a_text.empty())
        return a_deeper;
    return pointer(new output_filter_prefix(a_deeper, a_text));
}


ssize_t
libuncia::output_filter_prefix::write(const void *data, size_t size)
{
    const char *cp = (const char *)data;
    const char *ep = cp + size;
    while (cp < ep)
    {
        if (start_of_line)
        {
            deeper_puts(text);
            start_of_line = false;
        }
        char c = *cp++;
        deeper_putc(c);
        if (c == '\n')
            start_of_line = true;
    }
    return size;
}
