//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <libuncia/output/filter/rot47.h>


libuncia::output_filter_rot47::~output_filter_rot47()
{
}


static char map[UCHAR_MAX + 1];


libuncia::output_filter_rot47::output_filter_rot47(const pointer &a_deeper) :
    output_filter(a_deeper)
{
    if (!map[33])
    {
        for (unsigned j = 0; j <= UCHAR_MAX; ++j)
        {
            if (j >= '!' && j <= '~')
                map[j] = '!' + (j - '!' + 47) % 94;
            else
                map[j] = j;
        }
    }
}


libuncia::output::pointer
libuncia::output_filter_rot47::create(const pointer &a_deeper)
{
    return pointer(new output_filter_rot47(a_deeper));
}


ssize_t
libuncia::output_filter_rot47::write(const void *data, size_t size)
{
    const char *start = (const char *)data;
    const char *end = start + size;
    const char *cp = start;
    while (cp < end)
    {
        unsigned char c = *cp++;
        deeper_putc(map[c]);
    }
    return size;
}
