//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <iostream>
#include <libuncia/output/ostream.h>


libuncia::output_ostream::~output_ostream()
{
}


libuncia::output_ostream::output_ostream(std::ostream &a_deeper) :
    deeper(a_deeper)
{
}


libuncia::output::pointer
libuncia::output_ostream::create(std::ostream &a_deeper)
{
    return pointer(new output_ostream(a_deeper));
}


int
libuncia::output_ostream::sync()
{
    deeper << std::flush;
    return 0;
}


ssize_t
libuncia::output_ostream::write(const void *data, size_t size)
{
    deeper.write((const char *)data, size);
    return size;
}


std::string
libuncia::output_ostream::filename_get()
    const
{
    return "anonymous ostream";
}
