//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/output/tee.h>


libuncia::output_tee::~output_tee()
{
}


libuncia::output_tee::output_tee(const pointer &d1, const pointer &d2) :
    deeper1(d1),
    deeper2(d2)
{
}


libuncia::output_tee::pointer
libuncia::output_tee::create(const pointer &d1, const pointer &d2)
{
    return pointer(new output_tee(d1, d2));
}


int
libuncia::output_tee::sync()
{
    deeper1 << std::flush;
    deeper2 << std::flush;
    // FIXME: cope with errors
    return 0;
}


ssize_t
libuncia::output_tee::write(const void *data, size_t size)
{
    deeper1.write((const char *)data, size);
    deeper2.write((const char *)data, size);
    // FIXME: cope with errors
    return size;
}


std::string
libuncia::output_tee::filename_get()
    const
{
    return deeper1.filename_get();
}
