//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <libuncia/ostream.h>
#include <libuncia/output/filter/fold.h>
#include <libuncia/output/ostream.h>
#include <libuncia/progname.h>
#include <libuncia/print_version.h>
#include <libuncia/version.h>


void
libuncia::print_version()
{
    libuncia::ostream pretty_stdout
        (
            libuncia::output_filter_fold::create
            (
                libuncia::output_ostream::create(std::cout),
                true, // fold on spaces
                libuncia::output_filter_fold::get_terminal_width(),
                1     // tab width (don't use tabs)
            )
        );
    pretty_stdout << progname_get() << " version " << version() << "\n";
    pretty_stdout << "Copyright (C) " << copyright_years() << " "
        << copyright_owner() << "\n";
    pretty_stdout << "\n";
    pretty_stdout << "This program comes with ABSOLUTELY NO WARRANTY; "
        "for details see the LICENSE file in the source package.  This "
        "program is free software, and you are welcome to redistribute "
        "it under certain conditions; for details see the LICENSE file."
        << std::endl;
}
