//
// uncia - a big cat
// Copyright (C) 2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <cstdlib>
#include <cstdio>
#include <iostream>

#include <libuncia/ostream.h>
#include <libuncia/progname.h>
#include <libuncia/output/filter/fold.h>
#include <libuncia/output/ostream.h>
#include <libuncia/quit/stderr_and_exit.h>


libuncia::quit_stderr_and_exit::~quit_stderr_and_exit()
{
}


libuncia::quit_stderr_and_exit::quit_stderr_and_exit()
{
}


void
libuncia::quit_stderr_and_exit::exit(int n)
{
    ::exit(n);
}


void
libuncia::quit_stderr_and_exit::message_v(const char *fmt, va_list ap)
{
    char buf[2000];
    vsnprintf(buf, sizeof(buf), fmt, ap);

    std::cout.flush();

    libuncia::ostream pretty_stderr
        (
            libuncia::output_filter_fold::create
            (
                libuncia::output_ostream::create(std::cerr),
                true, // fold on spaces
                libuncia::output_filter_fold::get_terminal_width(),
                1,    // tab width (don't use tabs)
                4     // handing paragraph indent
            )
        );
    pretty_stderr << progname_get() << ": " << buf << std::endl;
}
