//
// uncia - a big cat
// Copyright (C) 2000, 2002, 2006-2008 Peter Miller
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 3, as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//

#include <stdexcept>

#include <libuncia/quit/throw_exception.h>


libuncia::quit_exception::~quit_exception()
{
}


libuncia::quit_exception::quit_exception()
{
}


void
libuncia::quit_exception::exit(int)
{
    std::runtime_error grenade(text.empty() ? "runtime error" : text);
    text.clear();
    throw grenade;
}


void
libuncia::quit_exception::message_v(const char *fmt, va_list ap)
{
    // we remember the text so that we can use it in the exception constructor,
    // allowing us to pass back a meaningful error message.
    char buf[2000];
    vsnprintf(buf, sizeof(buf), fmt, ap);
    text = buf;
}
