#!/bin/sh
#
# uncia - a big cat
# Copyright (C) 2008 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

TEST_SUBJECT="uncia -o -crlf"
. test_prelude

cat > test.in << 'fubar'
Hello,
World!
fubar
if test $? -ne 0; then no_result; fi

cat > test.ok.qp << 'fubar'
Hello,=0D
World!=0D
fubar
if test $? -ne 0; then no_result; fi

uncia test.ok.qp -qp -o test.ok
if test $? -ne 0; then no_result; fi

uncia test.in -o -crlf test.out
if test $? -ne 0; then fail; fi

cmp test.ok test.out
if test $? -ne 0; then fail; fi

#
# The things tested here, worked.
# No other guarantees are made.
#
pass

# vim:ts=8:sw=4:et
