#!/bin/sh
#
# uncia - a big cat
# Copyright (C) 2008 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

TEST_SUBJECT="class output_unexpand"
. test_prelude

cat > test.in << 'fubar'
a       a
        bb      bb
ccc     ccc
dddd    dddd
eeeee   eeeee
ffffff  ffffff
ggggggg ggggggg
hhhhhhhh        hhhhhhhh
fubar
if test $? -ne 0; then no_result; fi

cat > test.ok << 'fubar'
a^Ia
^Ibb^Ibb
ccc^Iccc
dddd^Idddd
eeeee^Ieeeee
ffffff^Iffffff
ggggggg ggggggg
hhhhhhhh^Ihhhhhhhh
fubar
if test $? -ne 0; then no_result; fi

uncia test.in -o --unexpand-all --show-tabs test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

cat > test.ok << 'fubar'
a       a
^Ibb      bb
ccc     ccc
dddd    dddd
eeeee   eeeee
ffffff  ffffff
ggggggg ggggggg
hhhhhhhh        hhhhhhhh
fubar
if test $? -ne 0; then no_result; fi

uncia test.in -o --unexpand --show-tabs test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

#
# The things tested here, worked.
# No other guarantees are made.
#
pass

# vim:ts=8:sw=4:et
