#!/bin/sh
#
# uncia - a big cat
# Copyright (C) 2008 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

TEST_SUBJECT="class input_gunzip"
. test_prelude

cat > test.ok << 'fubar'
Once a jolly swagman camped by a billabong,
Under the shade of a coolibah tree,
And he sang as he watched and waited till his billy boiled,
"Who'll come a-waltzing Matilda with me?
Waltzing Matilda, Waltzing Matilda,
Who'll come a-waltzing Matilda with me?"
And he sang as he watched and waited till his billy boiled,
"Who'll come a-waltzing Matilda with me?"

Down came a jumbuck to drink at the billabong:
Up jumped the swagman and grabbed him with glee.
And he sang as he shoved that jumbuck in his tucker-bag,
"You'll come a-waltzing Matilda with me.
Waltzing Matilda, Waltzing Matilda,
You'll come a-waltzing Matilda with me."
And he sang as he shoved that jumbuck in his tucker-bag,
"You'll come a-waltzing Matilda with me."

Up rode a squatter, mounted on his thoroughbred;
Down came the troopers, one, two, three:
"Who's that jolly jumbuck you've got in your tucker-bag?
You'll come a-waltzing Matilda with me!
Waltzing Matilda, Waltzing Matilda,
You'll come a-waltzing Matilda with me.
Who's that jolly jumbuck you've got in your tucker-bag?
You'll come a-waltzing Matilda with me!"

Up jumped the swagman and sprang into the billabong;
"You'll never catch me alive!" said he;
And his ghost may be heard as you pass by that billabong,
"You'll come a-waltzing Matilda with me!
Waltzing Matilda, Waltzing Matilda,
You'll come a-waltzing Matilda with me!"
And his ghost may be heard as you pass by that billabong,
"You'll come a-waltzing Matilda with me!"
fubar
if test $? -ne 0; then no_result; fi

gzip -9 < test.ok > test.in
if test $? -ne 0; then no_result; fi

uncia test.in -gunzip -o test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

#
# The things tested here, worked.
# No other guarantees are made.
#
pass

# vim:ts=8:sw=4:et
