#!/bin/sh
#
# uncia - a big cat
# Copyright (C) 2008 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

TEST_SUBJECT="output_fold"
. test_prelude

cat > test.in << 'fubar'
In view of the necessity in Entomology of =
the acceptance of a universal code of terms =
to differentiate or describe the parts or =
characteristics of insects, and owing to the =
absence of such a work, I have, through the =
courtesy of the authorities of the British Museum =
(Natural History), availed myself of the use of =
their extensive library to compile this book.

I also have to acknowledge my indebtedness =
to Professor F. V. Theobald for reading the =
proof-sheets, and for his valuable advice; to =
Mr. Gahan for the great interest he has taken in =
this publication; and to Miss E. H. Clemetson, =
Assoc. Inst. of Linguists, for revising the =
derivations.

I shall be happy to be notified of any omissions =
in this, the first edition, in order to render =
future issues more complete.
fubar
if test $? -ne 0; then no_result; fi

cat > test.ok << 'fubar'
In view of the necessity in Entomology of the acceptance of a universal code of
    terms to differentiate or describe the parts or characteristics of insects,
    and owing to the absence of such a work, I have, through the courtesy of the
    authorities of the British Museum (Natural History), availed myself of the
    use of their extensive library to compile this book.

I also have to acknowledge my indebtedness to Professor F. V. Theobald for
    reading the proof-sheets, and for his valuable advice; to Mr. Gahan for the
    great interest he has taken in this publication; and to Miss E. H.
    Clemetson, Assoc. Inst. of Linguists, for revising the derivations.

I shall be happy to be notified of any omissions in this, the first edition, in
    order to render future issues more complete.
fubar
if test $? -ne 0; then no_result; fi

uncia test.in -qp -o -fold-sp 80 1 4 test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

#
# The things tested here, worked.
# No other guarantees are made.
#
pass

# vim:ts=8:sw=4:et
