#!/bin/sh
#
# uncia - a big cat
# Copyright (C) 2008 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

TEST_SUBJECT="class input_filter_column_remove"
. test_prelude

cat > test.in << 'fubar'
Hello, World!
ab=09cd
a=08Zb=08Yc=08Xd=08We=08Vf=08Ug=08Th=08Si=08Rj=08Qk=08Pl=08Om=08N
fubar
if test $? -ne 0; then no_result; fi

cat > test.ok << 'fubar'
Hel World!
ab   cd
a=08Zb=08Yc=08Xg=08Th=08Si=08Rj=08Qk=08Pl=08Om=08N
fubar
if test $? -ne 0; then no_result; fi

uncia test.in -qp -colrm 4 7 -o -qp test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

# and also test the default stop

cat > test.ok << 'fubar'
Hel
ab=20
a=08Zb=08Yc=08X
fubar
if test $? -ne 0; then no_result; fi

uncia test.in -qp -colrm 4 -o -qp test.out
if test $? -ne 0; then fail; fi

diff test.ok test.out
if test $? -ne 0; then fail; fi

#
# The things tested here, worked.
# No other guarantees are made.
#
pass

# vim:ts=8:sw=4:et
