//
//      uncia - a big cat
//      Copyright (C) 2008 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <uncia/argument_source/gnu.h>


argument_source_gnu::~argument_source_gnu()
{
}


argument_source_gnu::argument_source_gnu(const pointer &a_deeper) :
    deeper(a_deeper)
{
}


argument_source_gnu::pointer
argument_source_gnu::create(const pointer &a_deeper)
{
    return pointer(new argument_source_gnu(a_deeper));
}


void
argument_source_gnu::error(const char *text)
    const
{
    deeper->error(text);
}


bool
argument_source_gnu::get(std::string &result)
{
    std::string s;
    if (!holding_pen.empty())
    {
        s = holding_pen.back();
        holding_pen.pop_back();
    }
    else
    {
        if (!deeper->get(s))
            return false;
    }
    if (s[0] == '-')
    {
        const char *eq = strchr(s.c_str(), '=');
        if (eq)
        {
            std::string left(s.c_str(), eq - s.c_str());
            ++eq;
            std::string right(eq, s.c_str() + s.size() - eq);
            holding_pen.push_back(right);
            s = left;
        }
    }
    if (s.size() >= 3 && s[0] == '-' && s[1] == '-')
        s = s.substr(1, s.size() - 1);
    result = s;
    return true;
}
